#include "_gen/svc-misc.h"

#include <telepathy-glib/dbus.h>
#include "_gen/signals-marshal.h"

static const DBusGObjectInfo _tpl_svc_logger_object_info;

struct _TplSvcLoggerClass {
    GTypeInterface parent_class;
    tpl_svc_logger_get_favourite_contacts_impl get_favourite_contacts_cb;
    tpl_svc_logger_add_favourite_contact_impl add_favourite_contact_cb;
    tpl_svc_logger_remove_favourite_contact_impl remove_favourite_contact_cb;
    tpl_svc_logger_clear_impl clear_cb;
    tpl_svc_logger_clear_account_impl clear_account_cb;
    tpl_svc_logger_clear_entity_impl clear_entity_cb;
};

enum {
    SIGNAL_LOGGER_FavouriteContactsChanged,
    N_LOGGER_SIGNALS
};
static guint logger_signals[N_LOGGER_SIGNALS] = {0};

static void tpl_svc_logger_base_init (gpointer klass);

GType
tpl_svc_logger_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (TplSvcLoggerClass),
        tpl_svc_logger_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "TplSvcLogger", &info, 0);
    }

  return type;
}

/**
 * tpl_svc_logger_get_favourite_contacts_impl:
 * @self: The object implementing this interface
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetFavouriteContacts on interface org.freedesktop.Telepathy.Logger.DRAFT.
 */
static void
tpl_svc_logger_get_favourite_contacts (TplSvcLogger *self,
    DBusGMethodInvocation *context)
{
  tpl_svc_logger_get_favourite_contacts_impl impl = (TPL_SVC_LOGGER_GET_CLASS (self)->get_favourite_contacts_cb);

  if (impl != NULL)
    {
      (impl) (self,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * tpl_svc_logger_implement_get_favourite_contacts:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetFavouriteContacts D-Bus method
 *
 * Register an implementation for the GetFavouriteContacts method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
tpl_svc_logger_implement_get_favourite_contacts (TplSvcLoggerClass *klass, tpl_svc_logger_get_favourite_contacts_impl impl)
{
  klass->get_favourite_contacts_cb = impl;
}

/**
 * tpl_svc_logger_add_favourite_contact_impl:
 * @self: The object implementing this interface
 * @in_Account: const gchar * (FIXME, generate documentation)
 * @in_Identifier: const gchar * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * AddFavouriteContact on interface org.freedesktop.Telepathy.Logger.DRAFT.
 */
static void
tpl_svc_logger_add_favourite_contact (TplSvcLogger *self,
    const gchar *in_Account,
    const gchar *in_Identifier,
    DBusGMethodInvocation *context)
{
  tpl_svc_logger_add_favourite_contact_impl impl = (TPL_SVC_LOGGER_GET_CLASS (self)->add_favourite_contact_cb);

  if (impl != NULL)
    {
      (impl) (self,
        in_Account,
        in_Identifier,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * tpl_svc_logger_implement_add_favourite_contact:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the AddFavouriteContact D-Bus method
 *
 * Register an implementation for the AddFavouriteContact method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
tpl_svc_logger_implement_add_favourite_contact (TplSvcLoggerClass *klass, tpl_svc_logger_add_favourite_contact_impl impl)
{
  klass->add_favourite_contact_cb = impl;
}

/**
 * tpl_svc_logger_remove_favourite_contact_impl:
 * @self: The object implementing this interface
 * @in_Account: const gchar * (FIXME, generate documentation)
 * @in_Identifier: const gchar * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * RemoveFavouriteContact on interface org.freedesktop.Telepathy.Logger.DRAFT.
 */
static void
tpl_svc_logger_remove_favourite_contact (TplSvcLogger *self,
    const gchar *in_Account,
    const gchar *in_Identifier,
    DBusGMethodInvocation *context)
{
  tpl_svc_logger_remove_favourite_contact_impl impl = (TPL_SVC_LOGGER_GET_CLASS (self)->remove_favourite_contact_cb);

  if (impl != NULL)
    {
      (impl) (self,
        in_Account,
        in_Identifier,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * tpl_svc_logger_implement_remove_favourite_contact:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the RemoveFavouriteContact D-Bus method
 *
 * Register an implementation for the RemoveFavouriteContact method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
tpl_svc_logger_implement_remove_favourite_contact (TplSvcLoggerClass *klass, tpl_svc_logger_remove_favourite_contact_impl impl)
{
  klass->remove_favourite_contact_cb = impl;
}

/**
 * tpl_svc_logger_clear_impl:
 * @self: The object implementing this interface
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * Clear on interface org.freedesktop.Telepathy.Logger.DRAFT.
 */
static void
tpl_svc_logger_clear (TplSvcLogger *self,
    DBusGMethodInvocation *context)
{
  tpl_svc_logger_clear_impl impl = (TPL_SVC_LOGGER_GET_CLASS (self)->clear_cb);

  if (impl != NULL)
    {
      (impl) (self,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * tpl_svc_logger_implement_clear:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the Clear D-Bus method
 *
 * Register an implementation for the Clear method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
tpl_svc_logger_implement_clear (TplSvcLoggerClass *klass, tpl_svc_logger_clear_impl impl)
{
  klass->clear_cb = impl;
}

/**
 * tpl_svc_logger_clear_account_impl:
 * @self: The object implementing this interface
 * @in_Account: const gchar * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * ClearAccount on interface org.freedesktop.Telepathy.Logger.DRAFT.
 */
static void
tpl_svc_logger_clear_account (TplSvcLogger *self,
    const gchar *in_Account,
    DBusGMethodInvocation *context)
{
  tpl_svc_logger_clear_account_impl impl = (TPL_SVC_LOGGER_GET_CLASS (self)->clear_account_cb);

  if (impl != NULL)
    {
      (impl) (self,
        in_Account,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * tpl_svc_logger_implement_clear_account:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the ClearAccount D-Bus method
 *
 * Register an implementation for the ClearAccount method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
tpl_svc_logger_implement_clear_account (TplSvcLoggerClass *klass, tpl_svc_logger_clear_account_impl impl)
{
  klass->clear_account_cb = impl;
}

/**
 * tpl_svc_logger_clear_entity_impl:
 * @self: The object implementing this interface
 * @in_Account: const gchar * (FIXME, generate documentation)
 * @in_Identifier: const gchar * (FIXME, generate documentation)
 * @in_Type: gint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * ClearEntity on interface org.freedesktop.Telepathy.Logger.DRAFT.
 */
static void
tpl_svc_logger_clear_entity (TplSvcLogger *self,
    const gchar *in_Account,
    const gchar *in_Identifier,
    gint in_Type,
    DBusGMethodInvocation *context)
{
  tpl_svc_logger_clear_entity_impl impl = (TPL_SVC_LOGGER_GET_CLASS (self)->clear_entity_cb);

  if (impl != NULL)
    {
      (impl) (self,
        in_Account,
        in_Identifier,
        in_Type,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * tpl_svc_logger_implement_clear_entity:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the ClearEntity D-Bus method
 *
 * Register an implementation for the ClearEntity method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
tpl_svc_logger_implement_clear_entity (TplSvcLoggerClass *klass, tpl_svc_logger_clear_entity_impl impl)
{
  klass->clear_entity_cb = impl;
}

/**
 * tpl_svc_logger_emit_favourite_contacts_changed:
 * @instance: The object implementing this interface
 * @arg_Account: const gchar * (FIXME, generate documentation)
 * @arg_Added: const gchar ** (FIXME, generate documentation)
 * @arg_Removed: const gchar ** (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * FavouriteContactsChanged signal on interface org.freedesktop.Telepathy.Logger.DRAFT.
 */
void
tpl_svc_logger_emit_favourite_contacts_changed (gpointer instance,
    const gchar *arg_Account,
    const gchar **arg_Added,
    const gchar **arg_Removed)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, TPL_TYPE_SVC_LOGGER));
  g_signal_emit (instance,
      logger_signals[SIGNAL_LOGGER_FavouriteContactsChanged],
      0,
      arg_Account,
      arg_Added,
      arg_Removed);
}

static inline void
tpl_svc_logger_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  dbus_g_object_type_install_info (tpl_svc_logger_get_type (),
      &_tpl_svc_logger_object_info);

  /**
   * TplSvcLogger::favourite-contacts-changed:
   * @arg_Account: const gchar * (FIXME, generate documentation)
   * @arg_Added: const gchar ** (FIXME, generate documentation)
   * @arg_Removed: const gchar ** (FIXME, generate documentation)
   *
   * The FavouriteContactsChanged D-Bus signal is emitted whenever this GObject signal is.
   */
  logger_signals[SIGNAL_LOGGER_FavouriteContactsChanged] =
  g_signal_new ("favourite-contacts-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _tpl_ext_marshal_VOID__BOXED_BOXED_BOXED,
      G_TYPE_NONE,
      3,
      DBUS_TYPE_G_OBJECT_PATH,
      G_TYPE_STRV,
      G_TYPE_STRV);

}
static void
tpl_svc_logger_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      tpl_svc_logger_base_init_once (klass);
    }
}
static const DBusGMethodInfo _tpl_svc_logger_methods[] = {
  { (GCallback) tpl_svc_logger_get_favourite_contacts, g_cclosure_marshal_VOID__POINTER, 0 },
  { (GCallback) tpl_svc_logger_add_favourite_contact, _tpl_ext_marshal_VOID__BOXED_STRING_POINTER, 95 },
  { (GCallback) tpl_svc_logger_remove_favourite_contact, _tpl_ext_marshal_VOID__BOXED_STRING_POINTER, 184 },
  { (GCallback) tpl_svc_logger_clear, g_cclosure_marshal_VOID__POINTER, 276 },
  { (GCallback) tpl_svc_logger_clear_account, _tpl_ext_marshal_VOID__BOXED_POINTER, 324 },
  { (GCallback) tpl_svc_logger_clear_entity, _tpl_ext_marshal_VOID__BOXED_STRING_INT_POINTER, 391 },
};

static const DBusGObjectInfo _tpl_svc_logger_object_info = {
  0,
  _tpl_svc_logger_methods,
  6,
"org.freedesktop.Telepathy.Logger.DRAFT\0GetFavouriteContacts\0A\0Favourite_Contacts\0O\0F\0N\0a(oas)\0\0org.freedesktop.Telepathy.Logger.DRAFT\0AddFavouriteContact\0A\0Account\0I\0o\0Identifier\0I\0s\0\0org.freedesktop.Telepathy.Logger.DRAFT\0RemoveFavouriteContact\0A\0Account\0I\0o\0Identifier\0I\0s\0\0org.freedesktop.Telepathy.Logger.DRAFT\0Clear\0A\0\0org.freedesktop.Telepathy.Logger.DRAFT\0ClearAccount\0A\0Account\0I\0o\0\0org.freedesktop.Telepathy.Logger.DRAFT\0ClearEntity\0A\0Account\0I\0o\0Identifier\0I\0s\0Type\0I\0i\0\0\0",
"org.freedesktop.Telepathy.Logger.DRAFT\0FavouriteContactsChanged\0\0",
"\0\0",
};


